<?php

$dbconn = false;

$dbdata = array(
                'host' => 'localhost',
                'user' => 'rcsuser',
                'pass' => 'rcspass',
                'db'   => 'rcs'
               );

function _db_init()
{
   global $dbconn, $dbdata;

   if(!($dbconn = mysql_connect($dbdata['host'], $dbdata['user'], $dbdata['pass']))) {
      return false;
   }
   if(!mysql_select_db($dbdata['db'], $dbconn)) {
      return false;
   }
   if(!mysql_set_charset('utf8')) {
      return false;
   }

   return true;
}

function _db_escape(&$arg)
{
   global $dbconn;

   switch(gettype($arg)) {
      case 'string':
         if(($arg = mysql_real_escape_string($arg, $dbconn)) === false) {
               return 'Generic database error';
            }
            break;
         case 'array':
            foreach($arg as &$a) {
               $ret = _db_escape($a);
               if(is_string($ret)) {
                  return $ret;
               }
            }
            break;
   }

   return true;
}

function db_escape($args)
{
   global $dbconn;

   if(!$dbconn) {
      if(!_db_init()) {
         return 'Generic database error';
      }
   }

   foreach($args as &$arg) {
      $ret = _db_escape($arg);
      if(is_string($ret)) {
         return $ret;
      }
   }

   return true;
}

function db_query($sql, $err_map = false)
{
   global $dbconn;

   if(!$dbconn) {
      if(!_db_init()) {
         return 'Generic database error';
      }
   }

   if(!($result = mysql_query($sql, $dbconn))) {
      if(isset($err_map[mysql_errno($dbconn)])) {
         return $err_map[mysql_errno($dbconn)];
      }
      return mysql_error($dbconn);
   }

   if($result === true) {
      return true;
   }

   if(mysql_num_rows($result) == 0) {
      mysql_free_result($result);
      return false;
   }

   $ret = array();

   while($row = mysql_fetch_object($result)) {
     array_push($ret, $row);
   }

   mysql_free_result($result);

   return $ret;
}

?>
