<?php

require_once('db.inc.php');

function login($user, $pass)
{
   $ret = db_escape(array(&$user,
                          &$pass));

   if(is_string($ret)) {
      return;
   }

   $sql  = "SELECT `user`, ";
   $sql .=        "`level` ";
   $sql .= "FROM `user` ";
   $sql .= "WHERE (`user` = '$user') AND ";
   $sql .=       "(`pass` = SHA1('$pass'))";

   $ret = db_query($sql);

   if(!isset($ret[0]->user)) {
      return;
   }

   $_SESSION['authuser'] = $ret[0]->user;
   $_SESSION['authlevel'] = $ret[0]->level;

   return;
}

function logout()
{
   unset($_SESSION['authlevel']);

   return session_destroy();
}

function redirect($page)
{
   $host = $_SERVER['HTTP_HOST'];
   $uri = rtrim(dirname($_SERVER['PHP_SELF']), '/\\');
   header("Location: http://$host$uri/$page");

   exit;
}

function checklevel($level)
{
   if(isset($_SESSION['authlevel']) && (($_SESSION['authlevel'] & $level) == $level)) {
      return true;
   }

   return false;
}

function showuser()
{
   $sql  = "SELECT `user`, ";
   $sql .=        "`level` ";
   $sql .= "FROM `user`";

   $ret = db_query($sql);

   return $ret;
}

function adduser($user, $pass, $level)
{
   $ret = db_escape(array(&$user,
                          &$pass,
                          &$level));

   if(is_string($ret)) {
      die($ret);
   }

   $sql  = "INSERT INTO `user` (`user`, ";
   $sql .=                     "`pass`, ";
   $sql .=                     "`level`) ";
   $sql .= "VALUES ('$user', ";
   $sql .=         "SHA1('$pass'), ";
   $sql .=         "'$level')";

   $ret = db_query($sql);
   
   if(is_object($ret)) {
      return $ret;
   }

   $sql  = "INSERT INTO `member` ";
   $sql .=    "SELECT '1' as `group_id`, ";
   $sql .=           "`user_id` ";
   $sql .=    "FROM `user` ";
   $sql .=    "WHERE `user` = '$user'";

   //$sql  = "INSERT INTO `member` (`group`, ";
   //$sql .=                     "`user`) ";
   //$sql .= "VALUES ('MainGroup', ";
   //$sql .=         "'$user')";

   $ret = db_query($sql);

   return $ret;
}

function moduser($user, $pass, $level)
{
   $ret = db_escape(array(&$user,
                          &$pass,
                          &$level));

   if(is_string($ret)) {
      die($ret);
   }

   $sql  = "UPDATE `user` ";
   $sql .= "SET ";
   $sql .= ($pass ? "`pass` = SHA1('$pass'), " : '');
   $sql .=     "`level` = $level ";
   $sql .= "WHERE `user` = '$user'";

   $ret = db_query($sql);

   return $ret;
}

function deluser($user)
{
   $ret = db_escape(array(&$user));

   if(is_string($ret)) {
      die($ret);
   }

   $sql  = "DELETE FROM `user` ";
   $sql .= "WHERE `user` = '$user'";

   $ret = db_query($sql);

   return $ret;
}

define('AL_VIEW', 0x01);   // viewer access
define('AL_TECH', 0x02);   // technician access
define('AL_SERV', 0x04);   // server access
define('AL_ADMN', 0x80);   // administrator access

?>
