<?php

require_once('functions.inc.php');

function loginaction()
{
   if(isset($_POST['authuser']) && isset($_POST['authpass'])) {
      login($_POST['authuser'], $_POST['authpass']);
   }

   return;
}

function logoutaction()
{
   logout();

   return;
}

function searchaction()
{
   return search($_POST['user'], $_POST['action'], $_POST['desc'], $_POST['begin'], $_POST['end'], $_POST['order']);
}

$action = (isset($_GET['action']) ? $_GET['action'] : '');

switch($action) {
   case 'login':
      loginaction();
      break;
   case 'logout':
      logoutaction();
      break;
   case 'search':
      if(checklevel(AL_ADMN)) {
         $lines = searchaction();
      }
      break;
   default:
      break;
}

if(checklevel(AL_ADMN)): 

$fields = getparam();

$i = 0;

?>
<html>
<head>
<meta http-equiv="content-type" content="text/html; charset=UTF-8">
<link rel="stylesheet" href="rcs.css" type="text/css">
</head>
<body>
<center>
<img src="img/logo.gif" style="float: left;">
<br>
<h1>HackingTeam RCS Activity Trace</h1>
Welcome <b><?=htmlspecialchars($_SESSION['authuser'])?></b> (<a href="?action=logout">logout</a>)
<br><br><br>
<form action="<?=$_SERVER['PHP_SELF']?>?action=search" method="POST">
<table border="0">
<tr class="title">
<td align="center"><input type="radio" name="order" value="action"<?=(($_POST['order'] == 'action') ? ' checked' : '')?>> <b>Action</b></td>
<td align="center"><input type="radio" name="order" value="desc"<?=(($_POST['order'] == 'desc') ? ' checked' : '')?>> <b>Target</b></td>
<td align="center"><input type="radio" name="order" value="user"<?=(($_POST['order'] == 'user') ? ' checked' : '')?>> <b>User</b></td>
<td colspan="2" align="center"><input type="radio" name="order" value="timestamp"<?=(($_POST['order'] == 'timestamp') ? ' checked' : '')?>> <b>From - To (yyyy-mm-dd hh:mm:ss)</b></td>
<td></td>
</tr>
<tr class="even">
<?php foreach(array('action', 'desc', 'user') as $field): ?>
<td>
<select name="<?=htmlspecialchars($field)?>">
<option value="">[ALL]</option>
<?php foreach($fields->$field as $value): ?>
<option value="<?=htmlspecialchars($value)?>"<?=(($_POST[$field] == $value) ? ' selected' : '')?>><?=htmlspecialchars($value)?></option>
<?php endforeach; ?>
</select>
<?php endforeach; ?>
<td>
<input type="text" name="begin" value="<?=(isset($_POST['begin']) ? htmlspecialchars($_POST['begin']) : '')?>">
</td>
<td>
<input type="text" name="end" value="<?=(isset($_POST['end']) ? htmlspecialchars($_POST['end']) : '')?>">
</td>
<td>
<input type="submit" value="SEARCH">
</td>
</table>
</form>
<br>
<?php if(isset($lines)): ?>
<?php if($lines !== false): ?>
<table border="0">
<tr class="title">
<td align="center"><b>Action</b></td>
<td align="center"><b>Target</b></td>
<td align="center"><b>User</b></td>
<td align="center"><b>Date</b></td>
</tr>
<?php foreach($lines as $line): ?>
<tr class="<?=(($i % 2) ? 'odd' : 'even')?>">
<td><?=htmlspecialchars($line->action)?></td>
<td><?=htmlspecialchars($line->desc)?></td>
<td><?=htmlspecialchars($line->user)?></td>
<td><?=htmlspecialchars($line->timestamp)?></td>
</tr>
<?php $i++; endforeach; ?>
</table>
<?php else: ?>
<h2>No trace matching</h2>
<?php endif; ?>
<?php endif; ?>
</center>
</body>
</html>
<?php

else:

?>
<html>
<head>
<meta http-equiv="content-type" content="text/html; charset=UTF-8">
<link rel="stylesheet" href="rcs.css" type="text/css">
</head>
<body>
<img src="img/logo.gif" style="float: left;">
<br><br><br>
<form action="<?=$_SERVER['PHP_SELF']?>?action=login" method="POST">
<center>
<table border="0" bgcolor="#ffffff">
<tr>
<td colspan="2"><img src="img/ht.gif"><br><br></td>
</tr>
<tr>
<td align="right">Username:</td>
<td><input style="width: 150px;" type="text" name="authuser"></td>
</tr>
<tr>
<td align="right">Password:</td>
<td><input style="width: 150px;" type="password" name="authpass"></td>
</tr>
<tr>
<td colspan="2" align="center"><input type="submit" value="LOGIN"><br><br></td>
</tr>
</table>
</center>
</form>
</body>
</html>
<?php

endif;

?>
