@echo off

if not "%~1" == "" goto ok
if not "%~2" == "" goto ok
if not "%~3" == "" goto ok
echo "Usage: RCSDB-install.bat <adminpass> <dbrootpass> <dbrcsuserpass>"
goto end

:ok
echo --------------------------------------------------
echo *** Setting PATH Environment variable ***
C:\RCSDB\imagemagick\uninstall\PathTool -silent -a:"C:\RCSDB\apache\bin;C:\RCSDB\php;C:\RCSDB\mysql\bin;C:\RCSDB\imagemagick;C:\RCSDB\gocr"

echo --------------------------------------------------
echo *** Configuring MySQL ***
C:\RCSDB\mysql\bin\mysqld-nt --install MySQL5.0 --defaults-file="C:\RCSDB\mysql\my.ini"
net start MySQL5.0
:loop
ping localhost > nul
C:\RCSDB\mysql\bin\mysql -b -e "quit" 2> nul
IF NOT %ERRORLEVEL% == 0 GOTO loop

echo --------------------------------------------------
echo *** Creating data ***
C:\RCSDB\mysql\bin\mysql -u root < C:\RCSDB\apache\htdocs\sql\db.sql
C:\RCSDB\mysql\bin\mysql -u root < C:\RCSDB\apache\htdocs\sql\user.sql
C:\RCSDB\mysql\bin\mysqladmin -u root password "%~2"
C:\RCSDB\mysql\bin\mysql -u rcsuser < C:\RCSDB\apache\htdocs\sql\data.sql
C:\RCSDB\mysql\bin\mysql -u rcsuser rcs -e "UPDATE `user` SET `pass` = SHA1('%~1') WHERE `user` = 'admin'"
C:\RCSDB\mysql\bin\mysql -u rcsuser -e "SET PASSWORD = PASSWORD('%~3')"

echo --------------------------------------------------
echo *** Configuring Apache ***
C:\RCSDB\apache\bin\openssl req -x509 -new -days 3650 -out C:\RCSDB\apache\conf\server.crt -newkey rsa:1024 -nodes -keyout C:\RCSDB\apache\conf\server.key -config C:\RCSDB\apache\conf\RCSDB-openssl.cnf
C:\RCSDB\apache\bin\httpd -k install
net start Apache2.2

echo --------------------------------------------------
echo *** Creating firewall rules ***
netsh firewall add portopening TCP 80 "Apache (HTTP)"
netsh firewall add portopening TCP 4443 "Apache (HTTPS)"

echo --------------------------------------------------

:end